<?
// This file contains functions used by the admin interface 

function display_category_form($category = "")
// This displays the category form.
// This form can be used for inserting or editing categories.
// To insert, don't pass any parameters.  This will set $edit
// to false, and the form will go to insert_category.php.
// To update, pass an array containing a category.  The
// form will contain the old data and point to update_category.php.
// It will also add a "Delete category" button.
{
  // if passed an existing category, proceed in "edit mode"
  $edit = is_array($category);

  // most of the form is in plain HTML with some
  // optional PHP bits throughout
?>
  <form method=post 
      action="<?=$edit?"edit_category.php":"insert_category.php";?>"> 
  <table border=0>
  <tr>
    <td>Category Name:</td>
    <td><input type=text name=category size=40 maxlength=40
          value="<?=$edit?$category["category"]:""; ?>"></td>
   </tr>
  <tr>
    <td <? if (!$edit) echo "colspan=2"; ?> align=center>
      <? if ($edit) 
         echo "<input type=hidden name=catid 
                value=\"".$category["catid"]."\">";
      ?>
      <input type=submit 
       value="<?=$edit?"Update":"Add"; ?> Category"></form>
     </td>
     <? if ($edit)
       // allow deletion of existing categories 
       {
          echo "<td>";
          echo "<form method=post action=\"delete_category.php\">";
          echo "<input type=hidden name=catid value=\"".$category[catid]."\">";
          echo "<input type=submit value=\"Delete category\">";
          echo "</form></td>";
       }
     ?>
  </tr>
  </table>
<?
}

function display_book_form($book = "")
// This displays the book form.
// It is very similar to the category form.
// This form can be used for inserting or editing books.
// To insert, don't pass any parameters.  This will set $edit
// to false, and the form will go to insert_book.php.
// To update, pass an array containing a book.  The
// form will be displayed with the old data and point to update_book.php.
// It will also add a "Delete book" button.
{
  
  // if passed an existing book, proceed in "edit mode"
  $edit = is_array($book);

  // most of the form is in plain HTML with some
  // optional PHP bits throughout
?>
  <form method=post
        action="<?=$edit?"edit_book.php":"insert_book.php";?>">
  <table border=0>
  <tr>
    <td>Short title:</td>
    <td><input type=text name=shortTitle size=25
         value="<?=$edit?$book["shortTitle"]:""; ?>"></td>
  </tr>
  <tr>
    <td>Title:</td>
    <td><input type=text name=title size=100
         value="<?=$edit?$book["title"]:""; ?>"></td>
  </tr>
    <tr>
    <td>Publisher:</td>
    <td><input type=text name=publisher size=100
         value="<?=$edit?$book["publisher"]:""; ?>"></td>
  </tr>
   <tr>
      <td>Category:</td>
      <td><select name=catid>
      <?
          $cat_array=get_categories();
          foreach ($cat_array as $thiscat)
          {
               echo "<option value=\"";
               echo $thiscat["catid"];
               echo "\"";
               if ($edit && $thiscat["catid"] == $book["catid"])
                   echo " selected";
               echo ">"; 
               echo $thiscat["category"];
               echo "\n"; 
          }
          ?>
          </select>
        </td>
   </tr>

	<?
   $des = $edit?$book["description"]:"";
   echo "<tr><td>Description</td><td> <textarea name=\"description\" cols=\"80\" rows=\"20\"> $des </textarea></td></tr>\n"; 
   $kw = $edit?$book["keywords"]:""; 
   echo "<tr><td>Keywords (terminated by period, comma separated)</td><td> <textarea name=\"keywords\" cols=\"80\" rows=\"10\">$kw</textarea></td></tr>\n";
	?>
	
   <tr>
      <td>Coverage unit:</td>
      <td><select name=covid>
      <?
          $cat_array=get_cov();
          foreach ($cat_array as $thiscat)
          {
               echo "<option value=\"";
               echo $thiscat["covid"];
               echo "\"";
               if ($edit && substr($thiscat["covid"],0,1) == $book["covid"])
                   echo " selected";
               echo ">"; 
               echo $thiscat["cov"];
               echo "\n"; 
          }
          ?>
          </select>
        </td>
   </tr>
      <tr>
      <td>Type:</td>
      <td><select name=typeid>
      <?
          $cat_array=get_type();
          foreach ($cat_array as $thiscat)
          {
               echo "<option value=\"";
               echo $thiscat["typeid"];
               echo "\"";
               if ($edit && substr($thiscat["typeid"],0,1) == $book["typeid"])
                   echo " selected";
               echo ">"; 
               echo $thiscat["type"];
               echo "\n"; 
          }
          ?>
          </select>
        </td>
   </tr>
   
   <tr>
      <td>Access methods:</td></tr>
      <?
      $cat_array=get_access();
      $j=0;
	  foreach ($cat_array as $thiscat)
	  {
	  	  $j++;
		  $t1=$thiscat["accid"];
		  $t2=$thiscat["access"];
	      echo "<tr><td></td><td><input type=\"checkbox\" name=\"accid$j\" value=\"$t1\"";
          if ($edit && substr($thiscat["accid"],0,1) == $book["accid$j"]) 
                   echo " checked";	      
	      echo ">$t2</td></tr>\n";
	   }
       ?>
      <tr><td>&nbsp;</td></tr>
      
      <tr>
      <td>Frequency:</td>
      <td><select name=freqid>
      <?
          $cat_array=get_freq();
          foreach ($cat_array as $thiscat)
          {
               echo "<option value=\"";
               echo $thiscat["freqid"];
               echo "\"";
               if ($edit && substr($thiscat["freqid"],0,1) == $book["freqid"])
                   echo " selected";
               echo ">"; 
               echo $thiscat["freq"];
               echo "\n"; 
          }
          ?>
          </select>
        </td>
   </tr>
   
   <tr>
    <td>Variables:</td>
    <td><input type=text name=variables size=20
               value="<?=$edit?$book["variables"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Cross Section Units:</td>
    <td><input type=text name=crossSectionUnits size=20
               value="<?=$edit?$book["crossSectionUnits"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Time Series Units:</td>
    <td><input type=text name=timeSeriesUnits size=20
               value="<?=$edit?$book["timeSeriesUnits"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Data Starts:</td>
    <td><input type=text name=dataStarts size=20
               value="<?=$edit?$book["dataStarts"]:""; ?>"></td>
   </tr>
      <tr>
    <td>Data Ends:</td>
    <td><input type=text name=dataEnds size=20
               value="<?=$edit?$book["dataEnds"]:""; ?>"></td>
   </tr>

    <tr>
    <td>Principal Investigator:</td>
    <td><input type=text name=principalInvestigator size=80
               value="<?=$edit?$book["principalInvestigator"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Contact for Assistance:</td>
    <td><input type=text name=contactAssistance size=40
               value="<?=$edit?$book["contactAssistance"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Comments:</td>
    <td><input type=text name=comments size=100
               value="<?=$edit?$book["comments"]:""; ?>"></td>
   </tr>
   <tr>
    <td>Quest Link:</td>
    <td><input type=text name=questLink size=100
               value="<?=$edit?$book["questLink"]:""; ?>"></td>
   </tr>
   <tr>
      <td colspan=2>Available packages / package URLs:</td></tr>
      <?
      $cat_array=get_pkg();
      $j=0;
	  foreach ($cat_array as $thiscat)
	  {
	  	  $j++;
		  $t1=$thiscat["pkgid"];
		  $t2=$thiscat["pkg"];
	      echo "<tr><td></td><td><input type=\"checkbox\" name=\"pkgid$j\" value=\"$t1\"";
          if ($edit && substr($thiscat["pkgid"],0,1) == $book["pkgid$j"])
                   echo " checked";	      
// must also set default value
          $v = $edit?$book["url$j"]:"";
	      echo ">$t2</td></tr><tr><td></td><td><input type=text name=url$j size=70 value=\"$v\"></td></tr>\n";
	   }
       ?>
       <tr><td>&nbsp;</td></tr>

   <tr>
    <td>Documentation URL:</td>
    <td><input type=text name=docURL size=80
               value="<?=$edit?$book["docURL"]:""; ?>"></td>
   </tr>
      <tr>
    <td>More Info URL:</td>
    <td><input type=text name=moreInfoURL size=80
               value="<?=$edit?$book["moreInfoURL"]:""; ?>"></td>
   </tr>
    <tr>
      <td <? if (!$edit) echo "colspan=2"; ?> align=center>
         <? 
            if ($edit)
            {
             // we need the old name to find candidate in database
             // if the name is being updated
			   $newcode=urlencode($book["shortTitle"]);
               echo "<input type=hidden name=newcode value=\"".$newcode."\">";           
            }
         ?>
        <input type=submit
               value="<?=$edit?"Update":"Add"; ?> entry">
        </form></td>
        <? 
           if ($edit)
           {  
             echo "<td>";
             echo "<form method=post action=\"delete_book.php\">";
      		 $newcode=urlencode($book["shortTitle"]);
      		 // echo "newcode is $newcode<br>"; 
             echo "<input type=hidden name=newcode value=\"".$newcode."\">";
             //       value=\"".$book["firstname"]."|".$book["lastname"]."\">";
             echo "<input type=submit 
                    value=\"Delete entry\">";
             echo "</form></td>";
            }
          ?>
         </td>
      </tr>
  </table>
  </form>
<?
}

function display_password_form()
{
// displays html change password form
?>
   <br>
   <form action="change_password.php" method=post>
   <table width=250 cellpadding=2 cellspacing=0 bgcolor=#cccccc>
   <tr><td>Old password:</td>
       <td><input type=password name=old_passwd size=16 maxlength=16></td>
   </tr>
   <tr><td>New password:</td>
       <td><input type=password name=new_passwd size=16 maxlength=16></td>
   </tr>
   <tr><td>Repeat new password:</td>
       <td><input type=password name=new_passwd2 size=16 maxlength=16></td>
   </tr>
   <tr><td colspan=2 align=center><input type=submit value="Change password">
   </td></tr>
   </table>
   <br>
<?
};

function insert_category($category)
// inserts a new category into the database
{
   $conn = db_connect();

   // check category does not already exist
   $query = "select *
             from VDCcats
             where category='$category'";
   $result = mysql_query($query);
   if (!$result || mysql_num_rows($result)!=0)
     return false;  

   // insert new category 
   $query = "insert into VDCcats values
            ('', '$category')"; 
   $result = mysql_query($query);
   if (!$result)
     return false;
   else
     return true;
}

function insert_book($shortTitle, $title, $publisher, $description, $keywords, $catid, $covid, $typeid, $accid1, $accid2, $accid3, $accid4, $accid5, $freqid, $pkgid1, $pkgid2, $pkgid3, $pkgid4, $pkgid5, $pkgid6, $pkgid7, $url1, $url2, $url3, $url4, $url5, $url6, $url7, $variables, $crossSectionUnits, $timeSeriesUnits, $dataStarts, $dataEnds, $principalInvestigator, $contactAssistance, $comments, $questLink, $docURL, $moreInfoURL, $dateMod) 
{
   $conn = db_connect();
 // check entry does not already exist
   $query = "select *
             from VDC 
             where shortTitle='$shortTitle'";
   $result = mysql_query($query);
   if (!$result || mysql_num_rows($result)!=0)
     return false;
   // insert new entry
//   echo "$accid1 $accid2 $accid3 $accid4 $accid5 " ;
   $dateMod = date("Y-m-d");
   $query = "insert into VDC values
            ('$shortTitle', '$title', '$publisher', '$description', '$keywords', '$catid', '$covid', '$typeid', '$accid1','$accid2','$accid3','$accid4','$accid5', '$freqid', '$pkgid1', '$pkgid2', '$pkgid3', '$pkgid4', '$pkgid5', '$pkgid6', '$pkgid7', '$url1', '$url2', '$url3', '$url4', '$url5', '$url6', '$url7', '$variables', '$crossSectionUnits', '$timeSeriesUnits', '$dataStarts', '$dataEnds', '$principalInvestigator', '$contactAssistance', '$comments', '$questLink', '$docURL', '$moreInfoURL', '$dateMod')";
// echo "$query<br>\n";
   $result = mysql_query($query);
   if (!$result)
     return false;
   else
	 return true;
}

function update_category($catid, $category)
// change the name of category with catid in the database
{
   $conn = db_connect();

   $query = "update VDCcats
             set category='$category'
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
     return true; 
}

function update_book($newcode, $shortTitle, $title, $publisher, $description, $keywords, $catid, $covid, $typeid, $accid1, $accid2, $accid3, $accid4, $accid5, $freqid, $pkgid1, $pkgid2, $pkgid3, $pkgid4, $pkgid5, $pkgid6, $pkgid7, $url1, $url2, $url3, $url4, $url5, $url6, $url7, $variables, $crossSectionUnits, $timeSeriesUnits, $dataStarts, $dataEnds, $principalInvestigator, $contactAssistance, $comments, $questLink, $docURL, $moreInfoURL, $dateMod)

// change details of course stored under $oldcode in
// the database to new details in arguments
{
   $conn = db_connect();
//   $dateArray = getdate();
   $dateMod = date("Y-m-d");
// echo "newcode is $newcode<br>"; 
   $oldST = urldecode($newcode); 

   $query = "update VDC
             set shortTitle='$shortTitle',
             title='$title',
             publisher = '$publisher',
             description = '$description',
             keywords = '$keywords',
             catid = '$catid',
             covid = '$covid',
             typeid = '$typeid',
             accid1 = '$accid1', accid2 = '$accid2', accid3 = '$accid3', accid4 = '$accid4', accid5 = '$accid5',
             freqid = '$freqid',
             pkgid1 = '$pkgid1', pkgid2 = '$pkgid2', pkgid3 = '$pkgid3', pkgid4 = '$pkgid4', pkgid5 = '$pkgid5', pkgid6 = '$pkgid6', pkgid7 = '$pkgid7',
             url1 = '$url1', url2 = '$url2', url3 = '$url3', url4 = '$url4', url5 = '$url5', url6 = '$url6', url7 = '$url7',
             variables = '$variables',
             crossSectionUnits = '$crossSectionUnits',
             timeSeriesUnits = '$timeSeriesUnits', 
             dataStarts = '$dataStarts',
             dataEnds = '$dataEnds',
             principalInvestigator = '$principalInvestigator',
             contactAssistance = '$contactAssistance',             
             comments = '$comments',
             questLink = '$questLink',
             docURL = '$docURL',              
             moreInfoURL = '$moreInfoURL',
             dateMod = '$dateMod'
             where shortTitle='$oldST'"; 

// echo "$query<br>\n";

   $result = @mysql_query($query);
   if (!$result) {
   echo "failure in update<br>";
     return false; }
   else
     return true; 
}

function delete_category($catid)
// Remove the category identified by catid from the db
// If there are courses in the category, it will not
// be removed and the function will return false.
{
   $conn = db_connect();
   
   // check if there are any courses in category 
   // to avoid deletion anomalies   
   $query = "select *
             from VDC
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result || @mysql_num_rows($result)>0)
     return false;

   $query = "delete from VDCcats 
             where catid='$catid'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
     return true; 
}


function delete_book($shortTitle)
{
   $conn = db_connect();

   $query = "delete from VDC
             where shortTitle='$shortTitle'";
   $result = @mysql_query($query);
   if (!$result)
     return false;
   else
   	 return true;
}

?>
