<?

function do_html_header($title = '')
{
  // print an HTML header
?>
  <!doctype html public "-//w3c//dtd html 4.0 strict//en">
  <html>
  <head>
    <title><?=$title?></title>
    <link rel="stylesheet" type="text/css" href="http://fmwww.bc.edu/ecstyle.css">
  </head>
  <body>

<?
  if($title)
    do_html_heading($title);
}

function do_html_footer()
{
  // print an HTML footer
?>
  </body>
  </html>
<?
}

function do_html_heading($heading)
{
  // print heading
?>
  <h2><?=$heading?></h2>
<?
}

function do_html_URL($url, $name)
{
  // output URL as link and br
?>
  <a href="<?=$url?>"><?=$name?></a><br>
<?
}

function display_categories($cat_array)
{
  if (!is_array($cat_array))
  {
     echo "No categories currently available<br>";
     return;
  }
  echo "<ul>";
  foreach ($cat_array as $row)
  {
    $count = get_category_count($row["catid"]);
//  echo $row["catid"]."|".$count;

    $url = "show_cat.php?catid=".($row["catid"]);
    $title = $row["category"]; 
    echo "<li>";
    do_html_url($url, $title); 
    echo "<div>[".$count." entries]</div>";
    echo "&nbsp;<br>";
  }    
  echo "</ul>";
  echo "<hr>";
}

function display_books($book_array)
{
  //display all books in the array passed in
  if (!is_array($book_array))
  {
     echo "<br>No entries currently listed in this category.<br>";
  }
  else
  {
    //create table
    echo "<table width = \"100%\" border = 0>";
    
    //create a table row for each book    
    foreach ($book_array as $row)
    {
      $url = "show_book.php?shortTitle=".(urlencode($row["shortTitle"]));
      echo "<tr><td>";
      echo "</td><td>";
      $title =  $row["title"];
      do_html_url($url, $title);
      echo "</td></tr>";
    }
    echo "</table>";
  }
  echo "<hr>";
}

function display_book_details($book)
{
  // display all details about this entry
  if (is_array($book))
  {
    extract($book);
    $access=compact('accid1','accid2','accid3','accid4','accid5');
	$pkg=compact('pkgid1','pkgid2','pkgid3','pkgid4','pkgid5','pkgid6','pkgid7');
	$url=compact('url1','url2','url3','url4','url5','url6','url7');
//    foreach($url as $k => $v) {
//    echo "url $k is $v<br>";
//    }
    echo "<table>"; 
    echo "<tr><td><b>Short Title / Title</b></td> ";
    echo "<td>".$book["shortTitle"]." : ".$book["title"]."</td></tr>";
	$cat = get_category_name($book["catid"]);
    echo "<tr><td><b>Category:</b></td>  ";
    echo "<td>".$cat."</td></tr>";
    echo "<tr><td><b>Publisher:</b></td>  ";
    echo "<td>".$book["publisher"]."</td></tr>";
    echo "<tr><td><b>Description:</b></td> ";
    echo "<td>".$book["description"]."</td></tr>";
    echo "<tr><td><b>Keywords:</b></td>  ";
    echo "<td>".$book["keywords"]."</td></tr>";
	$cov = get_cov_name($book["covid"]);
    echo "<tr><td><b>Coverage unit:</b></td>  ";
    echo "<td>".$cov."</td></tr>";   
    $type = get_type_name($book["typeid"]);
    echo "<tr><td><b>Organization:</b></td>  ";
    echo "<td>".$type."</td></tr>";  
    foreach($access as $k => $v) {
		if($v>0) { 
   			$acc = get_access_name("$v");
    		echo "<tr><td><b>Access method:</b></td> ";
	   		echo "<td>".$acc."</td></tr>";
    		}
    	}
    $freq = get_freq_name($book["freqid"]);
    echo "<tr><td><b>Data frequency:</b></td>  ";
    echo "<td>".$freq."</td></tr>"; 
// must deal with pkgid, url
    echo "<tr><td><b>Variables:</b></td>  ";
    echo "<td>".$book["variables"]."</td></tr>";
    echo "<tr><td><b>Cross section units:</b></td>  ";
    echo "<td>".$book["crossSectionUnits"]."</td></tr>";
    echo "<tr><td><b>Time series units:</b></td>  ";
    echo "<td>".$book["timeSeriesUnits"]."</td></tr>";
    echo "<tr><td><b>Data starts / ends :</b></td>  ";
    echo "<td>".$book["dataStarts"]." / ".$book["dataEnds"]."</td></tr>";
    echo "<tr><td><b>Principal investigator:</b></td>  ";
    echo "<td>".$book["principalInvestigator"]."</td></tr>";
    echo "<tr><td><b>Contact for assistance:</b></td>  ";
    echo "<td>".$book["contactAssistance"]."</td></tr>";
    echo "<tr><td><b>Comments:</b></td>  ";
    echo "<td>".$book["comments"]."</td></tr>";
    echo "<tr><td><b>Quest Link:</b></td>  ";
    echo "<td><a href=".$book["questLink"].">".$book["questLink"]."</a></td></tr>";
    foreach($pkg as $k => $v) {
		if($v>0) { 
   			$acc = get_pkg_name("$v");
    		echo "<tr><td><b>Package format/URL:</b></td> ";
	   		echo "<td>".$acc." : <a href=".$url["url$v"].">".$url["url$v"]."</a></td></tr>";
    		}
    	}
    echo "<tr><td><b>Documentation URL:</b></td>  ";
    echo "<td><a href=".$book["docURL"].">".$book["docURL"]."</a></td></tr>";
    echo "<tr><td><b>For more info URL:</b></td>  ";
    echo "<td><a href=".$book["moreInfoURL"].">".$book["moreInfoURL"]."</a></td></tr>";
    echo "<tr><td><b>Info updated:</b></td>  ";
    echo "<td>".$book["dateMod"]."</td></tr>";      
    echo "</table>"; 
  }
  else
    echo "The details of this entry cannot be displayed at this time.";
  echo "<hr>";
}


function display_login_form()
{
  // dispaly form asking for name and password
?>
  <form method=post action="admin.php">
  <table bgcolor=#cccccc>
   <tr>
     <td>Username:</td>
     <td><input type=text name=username></td></tr>
   <tr>
     <td>Password:</td>
     <td><input type=password name=passwd></td></tr>
   <tr>
     <td colspan=2 align=center>
     <input type=submit value="Log in"></td></tr>
   <tr>
 </table></form>
<?
}

function display_admin_menu()
{
?>
<br>
<p><a href="index.php">Display, update, delete entries</a></p>
<p><a href="insert_book_form.php">Add a new entry</a></p>
<!--<p><a href="insert_category_form.php">Add a new category</a></p>-->
<p><a href="DRdump.php">Dump templates for MARC conversion</a></p>
<p><a href="change_password_form.php">Change admin password</a></p>
<?

}

function display_button($target, $image, $alt)
{
  echo "<center><a href=\"$target\"><img src=\"images/$image".".gif\" 
           alt=\"$alt\" border=0 height = 50 width = 135></a></center>";
}

function display_form_button($image, $alt)
{
  echo "<center><input type = image src=\"images/$image".".gif\" 
           alt=\"$alt\" border=0 height = 50 width = 135></center>";
}

?>
